VERSION 5.00
Begin VB.Form FrmGraph 
   Caption         =   "Form2"
   ClientHeight    =   6390
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8790
   FillStyle       =   0  'Solid
   LinkTopic       =   "Form2"
   ScaleHeight     =   6390
   ScaleWidth      =   8790
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   225
      Left            =   2205
      TabIndex        =   2
      Top             =   105
      Width           =   2115
   End
   Begin VB.CommandButton BtAddGraph 
      Caption         =   "NewGraph"
      Height          =   225
      Left            =   525
      TabIndex        =   1
      Top             =   105
      Width           =   1170
   End
   Begin VB.PictureBox OGraph 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      DrawStyle       =   2  'Dot
      ForeColor       =   &H80000008&
      Height          =   1695
      Index           =   0
      Left            =   525
      ScaleHeight     =   1665
      ScaleWidth      =   2505
      TabIndex        =   0
      Top             =   2310
      Visible         =   0   'False
      Width           =   2535
   End
End
Attribute VB_Name = "FrmGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Type Grid
    Xname As String
    Yname As String
    XNameColor As Long
    YNameColor As Long
    XNameFont As String
    YNameFont As String
    XNameSize As Single
    YNameSize As Single
    Xstep As Single
    Ystep As Single
    Width As Single
    Style As Integer
    XLog As Boolean
    YLog As Boolean
End Type

Private Type Curve
    Clear As Boolean
    XOffset As Single
    YOffset As Single
    PenColor As Single
    PenStyle As Integer
    PenWidth As Integer
    Points() As Single
End Type

Private Type Graph
    Legend As String
    InUse As Boolean
    Top As Single
    Left As Single
    Height As Single
    Width As Single
    Color As Long
    Grids As Grid
    Curves As Curve
End Type

Dim Graphs() As Graph
Dim GraphsLoaded As Integer


Function NewGraph(T As Single, L As Single, H As Single, W As Single, S As String) As Integer
Dim i As Integer

    GraphsLoaded = GraphsLoaded + 1
    ReDim Preserve Graphs(GraphsLoaded)
    For i = 0 To UBound(Graphs)
        If Not Graphs(i).InUse Then 'It's free to use
            Graphs(i).InUse = True
            Exit For
        Else
            Load OGraph(GraphsLoaded - 1) 'Load a new one
            i = GraphsLoaded - 1
            Exit For
        End If
    Next
    With Graphs(i)
    .Top = T
    .Left = L
    .Height = H
    .Width = W
    .Color = RGB(0, 100, 0)
    .Legend = S
    ShowGraph (i)
    NewGraph = i
    End With
End Function


Private Sub BtAddGraph_Click()
Dim X As Integer
Static Y As Single

    X = NewGraph(500, 200, 4000, 14000, "Graphique")
    SetGrid X, "Perm", "B (Tesla)", 14, 5
    ShowGrid X
'    MsgBox "Nouveau graphe: " & X
    Y = Y + 2000
End Sub

Private Sub ShowGraph(Id As Integer)

    With Graphs(Id)
    OGraph(Id).Top = .Top
    OGraph(Id).Left = .Left
    OGraph(Id).Height = .Height
    OGraph(Id).Width = .Width
    OGraph(Id).BackColor = .Color
    OGraph(Id).Visible = True
    
    End With
End Sub

Private Sub SetGrid(Id As Integer, Xname As String, Yname As String, Xstep As Integer, Ystep As Integer)

    With Graphs(Id).Grids
    .Xname = Xname
    .Yname = Yname
    .XNameColor = RGB(128, 0, 0)
    .YNameColor = RGB(128, 128, 128)
    .XNameFont = "Arial"
    .YNameFont = "Arial"
    .XNameSize = 10
    .YNameSize = 10
    .Width = 1
    .Style = 0
    .Xstep = Graphs(Id).Width / Xstep
    .Ystep = Graphs(Id).Height / Ystep
    
    
    
    End With
End Sub
Private Sub ShowGrid(Id As Integer)
Dim N As Integer
Dim D As Single
    
    With Graphs(Id)
    N = .Height \ .Grids.Ystep
    D = .Height - 10
    OGraph(Id).DrawWidth = .Grids.Width
    OGraph(Id).DrawMode = 13
    OGraph(Id).DrawStyle = .Grids.Style
    OGraph(Id).ForeColor = .Grids.XNameColor
    OGraph(Id).CurrentX = .Grids.XNameSize
    OGraph(Id).CurrentY = .Grids.XNameSize
    OGraph(Id).FontName = .Grids.XNameFont
    OGraph(Id).FontSize = .Grids.XNameSize
    OGraph(Id).Print (.Grids.Xname)
    Do While N
        OGraph(Id).Line (0, D)-(.Width, D), , B
        D = D - .Grids.Ystep
        N = N - 1
    Loop
    N = .Width \ .Grids.Xstep
    D = .Width - 10
    OGraph(Id).ForeColor = .Grids.YNameColor
    OGraph(Id).CurrentX = .Width - OGraph(Id).TextWidth(.Grids.Yname & " ")
    OGraph(Id).CurrentY = .Height - OGraph(Id).TextHeight(" ") ' - OGraph(Id).TextHeight(" ")
    OGraph(Id).FontName = .Grids.YNameFont
    OGraph(Id).FontSize = .Grids.YNameSize
    OGraph(Id).Print (.Grids.Yname)
    Do While N
        OGraph(Id).Line (D, 0)-(D, .Height), , B
        D = D - .Grids.Xstep
        N = N - 1
    Loop
    End With
End Sub

Private Sub Plot(Id As Integer, Begin As Boolean, ByVal X As Single, ByVal Y As Single)


    With Graphs(Id).Curves
    Y = Graphs(Id).Height - Y
    If Begin Then
        .XOffset = X
        .YOffset = Y
        OGraph(Id).Cls
        ShowGraph (Id)
        ShowGrid (Id)
    Else
        OGraph(Id).ForeColor = vbYellow
        OGraph(Id).Line (.XOffset, .YOffset)-(X, Y)
        .XOffset = X
        .YOffset = Y
    End If
    End With
End Sub

Private Sub Command1_Click()
Dim X As Single
Dim Y As Single
Static A As Single
Static B As Single

'    A = A + 0.1
'    Y = A + B
    Plot 0, True, X, Y
    For X = 1 To 6800
        Y = 1000 + (X / 900) ^ 3.8
        Plot 0, False, X, Y
    Next X
    For X = 7200 To 14000
'        Y = Y - ((Abs(Y / 2000)))
        Y = Y - (Y / 3000)
        '        Y = Y - (Y / 2000) + ((X - 7000) / 100)
        Plot 0, False, X, Y
    Next X
End Sub

